/****************************************************************************
	PROGRAM :	OS2TERM
	PURPOSE :	Simple 16 bit routine giving example API calls
	VERSION :	2.0
	DATE	:	REVISED 10/3/95

	NOTES 	:	MSC 6.00
			CL -c -AS -Zi -G2 -W4 os2term.c
			LINK /CO os2term,,,,os2term.def;

			Porting to IBM C/SET2 requires changing of
			DosDevIOCtl format to DosDevIOCtl2 format
****************************************************************************/

#define INCL_BASE
#define INCL_DOSDEVICES
#define INCL_DOS
#define INCL_SUB

#define TRUE	1
#define	FALSE	0
#define CH_RECV	1
#define BS	0x08
#define LF	0x0a
#define CR	0x0d
#define SP	0x20
#define TILDE	0x7e

#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>

struct _LineControl 
{      
  BYTE bDataBits;  
  BYTE bParity;    
  BYTE bStopBits;  
} LineControl;

DCBINFO DCBInfo;

void main(int argc, char *argv[])
{
  HFILE handle;                    /* file handle for the first device  */
  USHORT usResult;              /* system returns result of action taken  */
  UCHAR  ch_recv;		/* read ch */
  UCHAR  ch_send;     		/* write ch */
  USHORT usBaudRate;
  USHORT usBytesRead;
  USHORT usBytesWritten;
  USHORT opt;
  UCHAR  portname[8];       /* ports name */
  UCHAR  erase[4]= {BS,SP,BS,0};
  UCHAR  crlf[3]= {CR,LF,0};
 
	printf("\nOS2TERM V1.00 For Hostess intelligent Controllers");
	printf("\n_________________________________________________\n\n");
	
	/* open the device for Read, and Write */
	if (argc <3)
	{
		printf("type port name: ");
     		gets(portname);
  	}
  	else 
		sprintf(portname,"%s",argv[1]);

  	if(DosOpen(portname,&handle,&usResult,0L,FILE_NORMAL,FILE_OPEN,
				OPEN_SHARE_DENYWRITE|OPEN_ACCESS_READWRITE,0L))	 
	{  

      		perror("OS2TERM : Failed DosOpen");
		fprintf(stderr,"Port = %s\n",portname);
      		exit(1);
  	}
	
	printf("Do you wish to change the Comms parameters [YN] -> ");
	opt = getche();
        opt = toupper(opt);
	if(opt == 'Y')
	{
		printf("\nBaud -> ");
		scanf("%d",&usBaudRate);
		printf("\nDatabits/ch -> ");
		scanf("%x",&LineControl.bDataBits);
		printf("Parity -> ");
		scanf("%x",&LineControl.bParity);
		printf("Stopbits/ch -> ");
		scanf("%x",&LineControl.bStopBits);
	}
        else
        {
		printf("\n");
                usBaudRate = 9600;
                LineControl.bDataBits = 0x08;
                LineControl.bParity = 0x0;
                LineControl.bStopBits = 0x0;
        }

  	if(DosDevIOCtl(0L, &usBaudRate, ASYNC_SETBAUDRATE, IOCTL_ASYNC, handle))
	{
		perror("OS2TERM : Failed ASYNC_SETBAUDRATE");
		DosClose(handle);
		exit(1);
	}  


  	if(DosDevIOCtl(0L, &LineControl, ASYNC_SETLINECTRL, IOCTL_ASYNC, handle))
	{
		perror("OS2TERM : Failed ASYNC_SETLINECTRL");
		DosClose(handle);
		exit(1);
	}


  	if(DosDevIOCtl(&DCBInfo, 0L, ASYNC_GETDCBINFO, IOCTL_ASYNC, handle))
	{
		perror("OS2TERM : Failed ASYNC_GETDCBINFO");
		DosClose(handle);
		exit(1);
	}

	/*  Set values in DCBInfo structure for ASYNC_SETDCBINFO function  */

	DCBInfo.usWriteTimeout = 100;
	DCBInfo.usReadTimeout = 0;
	DCBInfo.fbCtlHndShake = MODE_DTR_CONTROL;
	DCBInfo.fbFlowReplace = MODE_RTS_CONTROL;
	DCBInfo.fbTimeout = MODE_READ_TIMEOUT;

  	if(DosDevIOCtl(0L, &DCBInfo, ASYNC_SETDCBINFO, IOCTL_ASYNC, handle))
	{
		perror("OS2TERM : Failed ASYNC_SETDCBINFO");
		DosClose(handle);
		exit(1);
	}

  	for(;;)
  	{
      		if (kbhit())
		{
          		ch_send=(char)getch();
              		if (ch_send == '\x1b')
              			break;
			else
          			if(DosWrite(handle,&ch_send,1,&usBytesWritten))
				{
					perror("OS2TERM : Failed DosWrite");
					break;
				}
		}	
	
      		if(DosRead(handle, &ch_recv, 1, &usBytesRead))
		{
			perror("OS2TERM : Failed DosRead");
			break;
		}
		if(usBytesRead > 0)
			if((ch_recv >= SP) && (ch_recv <= TILDE))
				putchar(ch_recv);
			else
      				switch(ch_recv)
				{
					case BS : fprintf(stdout,"%s",erase);
						  break;
			
					case CR : fprintf(stdout,"%s",crlf);
				  		  break;
		
					default	: break;
				}
  	}
	
	DosClose(handle);
        exit(0);
}
